package com.jeeplus.ccpm.approvalInfo.controller;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.jeeplus.ccpm.approvalInfo.domain.CcpmReimbursementAmountInfo;
import com.jeeplus.ccpm.approvalInfo.mapper.CcpmReimbursementAmountInfoMapper;
import com.jeeplus.ccpm.approvalInfo.mapper.CcpmReimbursementInfoMapper;
import com.jeeplus.ccpm.approvalInfo.service.dto.CcpmReimAmountAndFileDto;
import com.jeeplus.sys.domain.WorkAttachmentInfo;
import com.jeeplus.sys.feign.IUserApi;
import com.jeeplus.sys.feign.IWorkAttachmentApi;
import com.jeeplus.utils.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class updateOldData {
    @Resource
    private CcpmReimbursementInfoMapper infoMapper;
    @Resource
    private CcpmReimbursementAmountInfoMapper amountInfoMapper;


    @PostConstruct
    public void init() {
        executeFileProcessing();
    }
    @Transactional
    public void executeFileProcessing() {
        //查询所有的数电发票信息
        LambdaQueryWrapper<CcpmReimbursementAmountInfo> invoiceReimbursementsLambdaQueryWrapper = new LambdaQueryWrapper<>();
        invoiceReimbursementsLambdaQueryWrapper.eq(CcpmReimbursementAmountInfo::getReimbursementType, "1");
        invoiceReimbursementsLambdaQueryWrapper.eq(CcpmReimbursementAmountInfo::getDelFlag, "0");
        List<CcpmReimbursementAmountInfo> invoiceReimbursements = amountInfoMapper.selectList(invoiceReimbursementsLambdaQueryWrapper);
        if (CollectionUtil.isNotEmpty(invoiceReimbursements)){
            for (CcpmReimbursementAmountInfo invoiceReimbursement : invoiceReimbursements) {
                // 查询附件信息
                List<WorkAttachmentInfo> fileList = infoMapper.findReimFiles(invoiceReimbursement.getInfoId());
                // 用于存储所有的 attachmentId
                List<String> attachmentIds = new ArrayList<>();
                if (CollectionUtil.isNotEmpty(fileList)) {
                    // 首先收集所有的 attachmentId
                    for (WorkAttachmentInfo workAttachmentInfo : fileList) {
                        attachmentIds.add(workAttachmentInfo.getAttachmentId());
                    }
                    if (CollectionUtil.isNotEmpty(attachmentIds)) {
                        Map<String, String> map = SpringUtil.getBean(IWorkAttachmentApi.class).disposeElectronicEngineeringInvoiceNumber(attachmentIds, "3");
                        // 处理结果的逻辑
                        if (map != null && !map.isEmpty()) {
                            for (WorkAttachmentInfo workAttachmentInfo : fileList) {
                                for (Map.Entry<String, String> entry : map.entrySet()) {
                                    String key = entry.getKey();
                                    String value = entry.getValue();

                                    if (StringUtils.isNotBlank(value) && key.equals(invoiceReimbursement.getNumber())) {
                                        // 如果 value 非空且 key 匹配，则执行修改操作
                                        invoiceReimbursement.setFileUrl(workAttachmentInfo.getUrl());
                                        invoiceReimbursement.setFileType(workAttachmentInfo.getType());
                                        invoiceReimbursement.setAttachmentName(workAttachmentInfo.getName());
                                        invoiceReimbursement.setAttachmentFlag("invoiceReimbursement");
                                        invoiceReimbursement.setFileSize(workAttachmentInfo.getFileSize());
                                        amountInfoMapper.updateById(invoiceReimbursement);

                                    }

                                }
                            }
                        }
                    }
                }
            }
        }
    }
}